// **************************
// Start of the Input Buffers
// Input Flip Flops  
// **************************

module IBUFDS_FD_LVDS (I,IB,C,Q);
input I, IB, C;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute FD IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FD off_p (.D(I_w), .C(C), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));
endmodule // IBUFDS_FD_LVDS

module IBUFDS_FDE_LVDS (I,IB,CE,C,Q);
input I, IB, CE, C;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_FDE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FDE off_p (.D(I_w), .CE(CE), .C(C), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_FDE_LVDS 

module IBUFDS_FDC_LVDS (I,IB,C,CLR,Q);
input I, IB, C, CLR;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_FDC_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FDC off_p (.D(I_w), .C(C), .CLR(CLR), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_FDC_LVDS 

module IBUFDS_FDCE_LVDS (I,IB,CE,C,CLR,Q);
input I, IB, CE, C, CLR;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_FDCE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FDCE off_p (.D(I_w), .CE(CE), .C(C), .CLR(CLR), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_FDCE_LVDS

module IBUFDS_FDP_LVDS (I,IB,C,PRE,Q);
input I, IB, C, PRE;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_FDP_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FDP off_p (.D(I_w), .C(C), .PRE(PRE), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_FDP_LVDS

module IBUFDS_FDPE_LVDS (I,IB,CE,C,PRE,Q);
input I, IB, CE, C, PRE;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_FDPE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FDPE off_p (.D(I_w),   .CE(CE), .C(C), .PRE(PRE), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_FDPE_LVDS

module IBUFDS_FDR_LVDS (I,IB,C,R,Q);
input I, IB, C, R;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_FDR_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FDR off_p (.D(I_w), .C(C), .R(R), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_FDR_LVDS

module IBUFDS_FDRE_LVDS (I,IB,CE,C,R,Q);
input I, IB, CE, C, R;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_FDRE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FDRE off_p (.D(I_w),   .CE(CE), .C(C), .R(R), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_FDRE_LVDS

module IBUFDS_FDS_LVDS (I,IB,C,S,Q);
input I, IB, C, S;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_FDS_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FDS off_p (.D(I_w), .C(C), .S(S), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_FDS_LVDS

module IBUFDS_FDSE_LVDS (I,IB,CE,C,S,Q);
input I, IB, CE, C, S;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_FDSE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

FDSE off_p (.D(I_w),   .CE(CE), .C(C), .S(S), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_FDSE_LVDS

// *************
// Input Latches
// *************
module IBUFDS_LD_LVDS (I,IB,G,Q);
input I, IB, G;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_LD_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

LD olatch_p (.D(I_w), .G(G), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_LD_LVDS

module IBUFDS_LDE_LVDS (I,IB,GE,G,Q);
input I, IB, GE, G;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_LDE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

LDE olatch_p (.D(I_w), .GE(GE), .G(G), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_LDE_LVDS 

module IBUFDS_LDC_LVDS (I,IB,G,CLR,Q);
input I, IB, G, CLR;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_LDC_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

LDC olatch_p (.D(I_w), .G(G), .CLR(CLR), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_LDC_LVDS 

module IBUFDS_LDCE_LVDS (I,IB,GE,G,CLR,Q);
input I, IB, GE, G, CLR;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_LDCE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

LDCE olatch_p (.D(I_w), .GE(GE), .G(G), .CLR(CLR), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_LDCE_LVDS

module IBUFDS_LDP_LVDS (I,IB,G,PRE,Q);
input I, IB, G, PRE;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_LDP_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

LDP olatch_p (.D(I_w), .G(G), .PRE(PRE), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_LDP_LVDS

module IBUFDS_LDPE_LVDS (I,IB,GE,G,PRE,Q);
input I, IB, GE, G, PRE;
output Q;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IBUFDS_LDPE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire I_w, IB_w;

LDPE olatch_p (.D(I_w),   .GE(GE), .G(G), .PRE(PRE), .Q(Q));
IBUF_LVDS pad_p (.I(I),  .O(I_w));
IBUF_LVDS pad_n (.I(IB), .O(IB_w));

endmodule // IBUFDS_LDPE_LVDS

// ***************************
// Start of the Output Buffers
// Output Flipflops
// ***************************

module OBUFDS_FD_LVDS (D,C,O,OB);
input D, C;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FD_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;
wire CLR = 0; // Used to ensure that p and n are opposite on reset

INV  inv_n (.I(D), .O(D_n));
FDC off_p (.D(D), .C(C), .CLR(CLR), .Q(q_p));
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FD_LVDS

module OBUFDS_FDE_LVDS (D,CE,C,O,OB);
input D, CE, C;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FDE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;
wire CLR = 0; // Used to ensure that p and n are opposite on reset

INV  inv_n (.I(D), .O(D_n));
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p));
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FDE_LVDS

module OBUFDS_FDC_LVDS (D,C,CLR,O,OB);
input D, C, CLR;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FDC_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p));
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FDC_LVDS

module OBUFDS_FDCE_LVDS (D,CE,C,CLR,O,OB);
input D, CE, C, CLR;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FDCE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p));
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FDCE_LVDS

module OBUFDS_FDP_LVDS (D,C,PRE,O,OB);
input D, C, PRE;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FDP_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
FDP off_p (.D(D),   .C(C), .PRE(PRE), .Q(q_p));
FDC off_n (.D(D_n), .C(C), .CLR(PRE), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FDP_LVDS

module OBUFDS_FDPE_LVDS (D,CE,C,PRE,O,OB);
input D, CE, C, PRE;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FDPE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
FDPE off_p (.D(D),   .CE(CE), .C(C), .PRE(PRE), .Q(q_p));
FDCE off_n (.D(D_n), .CE(CE), .C(C), .CLR(PRE), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FDPE_LVDS

module OBUFDS_FDR_LVDS (D,C,R,O,OB);
input D, C, R;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FDR_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
FDR off_p (.D(D),   .C(C), .R(R), .Q(q_p));
FDS off_n (.D(D_n), .C(C), .S(R), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FDR_LVDS

module OBUFDS_FDRE_LVDS (D,CE,C,R,O,OB);
input D, CE, C, R;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FDRE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
FDRE off_p (.D(D),   .CE(CE), .C(C), .R(R), .Q(q_p));
FDSE off_n (.D(D_n), .CE(CE), .C(C), .S(R), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FDRE_LVDS

module OBUFDS_FDS_LVDS (D,C,S,O,OB);
input D, C, S;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FDS_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
FDS off_p (.D(D),   .C(C), .S(S), .Q(q_p));
FDR off_n (.D(D_n), .C(C), .R(S), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FDS_LVDS

module OBUFDS_FDSE_LVDS (D,CE,C,S,O,OB);
input D, CE, C, S;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_FDSE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
FDSE off_p (.D(D),   .CE(CE), .C(C), .S(S), .Q(q_p));
FDRE off_n (.D(D_n), .CE(CE), .C(C), .R(S), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_FDSE_LVDS

// **************
// Output Latches
// **************

module OBUFDS_LD_LVDS (D,G,O,OB);
input D, G;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_LD_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;
wire CLR = 0; // Used to ensure that p and n are opposite on reset

INV  inv_n (.I(D), .O(D_n));
LDC olatch_p (.D(D), .G(G), .CLR(CLR), .Q(q_p));   
		;
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_LD_LVDS

module OBUFDS_LDE_LVDS (D,GE,G,O,OB);
input D, GE, G;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_LDE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;
wire CLR = 0; // Used to ensure that p and n are opposite on reset

INV  inv_n (.I(D), .O(D_n));
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p));
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_LDE_LVDS

module OBUFDS_LDC_LVDS (D,G,CLR,O,OB);
input D, G, CLR;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_LDC_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p));
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_LDC_LVDS

module OBUFDS_LDCE_LVDS (D,GE,G,CLR,O,OB);
input D, GE, G, CLR;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_LDCE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p));
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_LDCE_LVDS

module OBUFDS_LDP_LVDS (D,G,PRE,O,OB);
input D, G, PRE;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_LDP_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
LDP olatch_p (.D(D),   .G(G), .PRE(PRE), .Q(q_p));
LDC olatch_n (.D(D_n), .G(G), .CLR(PRE), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_LDP_LVDS

module OBUFDS_LDPE_LVDS (D,GE,G,PRE,O,OB);
input D, GE, G, PRE;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFDS_LDPE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n;

INV  inv_n (.I(D), .O(D_n));
LDPE olatch_p (.D(D),   .GE(GE), .G(G), .PRE(PRE), .Q(q_p));
LDCE olatch_n (.D(D_n), .GE(GE), .G(G), .CLR(PRE), .Q(q_n));
OBUF_LVDS pad_p (.I(q_p), .O(O));
OBUF_LVDS pad_n (.I(q_n), .O(OB));

endmodule // OBUFDS_LDPE_LVDS

// *************************************
// Start of the Tri-State Output Buffers
// Tri-state output flipflops
// *************************************

module OBUFTDS_FD_LVDS (D,T,C,O,OB);
input D, T, C;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFTDS_FD_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;
wire CLR = 0;

INV inv_n (.I(D), .O(D_n));
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p));
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n));
FDP tri_p (.D(T),   .C(C), .PRE(CLR), .Q(t_p));
FDP tri_n (.D(T),   .C(C), .PRE(CLR), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FD_LVDS

module OBUFTDS_FDE_LVDS (D,T,CE,C,O,OB);
input D, T, CE, C;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFTDS_FDE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n));
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p)); 
	;
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n));
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_p));
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FDE_LVDS
 
module OBUFTDS_FDC_LVDS (D,T,C,CLR,O,OB);
input D, T, C, CLR;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFTDS_FDC_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV inv_n (.I(D), .O(D_n));
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p));
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n));
FDP tri_p (.D(T),   .C(C), .PRE(CLR), .Q(t_p));
FDP tri_n (.D(T),   .C(C), .PRE(CLR), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FDC_LVDS

module OBUFTDS_FDCE_LVDS (D,T,CE,C,CLR,O,OB);
input D, T, CE, C, CLR;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFTDS_FDCE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p));
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n));
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_p));
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FDCE_LVDS

module OBUFTDS_FDP_LVDS (D,T,C,PRE,O,OB);
input D, T, C, PRE;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute OBUFTDS_FDP_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
FDP off_p (.D(D),   .C(C), .PRE(PRE), .Q(q_p));
FDC off_n (.D(D_n), .C(C), .CLR(PRE), .Q(q_n));
FDP tri_p (.D(T),   .C(C), .PRE(PRE), .Q(t_p));
FDP tri_n (.D(T),   .C(C), .PRE(PRE), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FDP_LVDS

module OBUFTDS_FDPE_LVDS (D,T,CE,C,PRE,O,OB);
input D, T, CE, C, PRE;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute OBUFTDS_FDPE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
FDPE off_p (.D(D),   .CE(CE), .C(C), .PRE(PRE), .Q(q_p));
FDCE off_n (.D(D_n), .CE(CE), .C(C), .CLR(PRE), .Q(q_n));
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(PRE), .Q(t_p));
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(PRE), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FDPE_LVDS

module OBUFTDS_FDR_LVDS (D,T,C,R,O,OB);
input D, T, C, R;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute OBUFTDS_FDR_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
FDR off_p (.D(D),   .C(C), .R(R), .Q(q_p));
FDS off_n (.D(D_n), .C(C), .S(R), .Q(q_n));
FDS tri_p (.D(T),   .C(C), .S(R), .Q(t_p));
FDS tri_n (.D(T),   .C(C), .S(R), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FDR_LVDS

module OBUFTDS_FDRE_LVDS (D,T,CE,C,R,O,OB);
input D, T, CE, C, R;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute OBUFTDS_FDRE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
FDRE off_p (.D(D),   .CE(CE), .C(C), .R(R), .Q(q_p));
FDSE off_n (.D(D_n), .CE(CE), .C(C), .S(R), .Q(q_n));
FDSE tri_p (.D(T),   .CE(CE), .C(C), .S(R), .Q(t_p));
FDSE tri_n (.D(T),   .CE(CE), .C(C), .S(R), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FDRE_LVDS

module OBUFTDS_FDS_LVDS (D,T,C,S,O,OB);
input D, T, C, S;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute OBUFTDS_FDS_IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
FDS off_p (.D(D),   .C(C), .S(S), .Q(q_p));
FDR off_n (.D(D_n), .C(C), .R(S), .Q(q_n));
FDS tri_p (.D(T),   .C(C), .S(S), .Q(t_p));
FDS tri_n (.D(T),   .C(C), .S(S), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FDS_LVDS

module OBUFTDS_FDSE_LVDS (D,T,CE,C,S,O,OB);
input D, T, CE, C, S;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute OBUFTDS_FDSE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
FDSE off_p (.D(D),   .CE(CE), .C(C), .S(S), .Q(q_p));
FDRE off_n (.D(D_n), .CE(CE), .C(C), .R(S), .Q(q_n));
FDSE tri_p (.D(T),   .CE(CE), .C(C), .S(S), .Q(t_p));
FDSE tri_n (.D(T),   .CE(CE), .C(C), .S(S), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_FDSE_LVDS

// ************************
// Tri-state output LATCHES
// ************************

module OBUFTDS_LD_LVDS (D,T,G,O,OB);
input D, T, G;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFTDS_LD_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;
wire CLR = 0;

INV inv_n (.I(D), .O(D_n));
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p));
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n));
LDP tri_p (.D(T),   .G(G), .PRE(CLR), .Q(t_p));
LDP tri_n (.D(T),   .G(G), .PRE(CLR), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_LD_LVDS

module OBUFTDS_LDE_LVDS (D,T,GE,G,O,OB);
input D, T, GE, G;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFTDS_LDE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n));
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p));
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n));
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_p));
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_LDE_LVDS
 
module OBUFTDS_LDC_LVDS (D,T,G,CLR,O,OB);
input D, T, G, CLR;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFTDS_LDC_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV inv_n (.I(D), .O(D_n));
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p));
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n));
LDP tri_p (.D(T),   .G(G), .PRE(CLR), .Q(t_p));
LDP tri_n (.D(T),   .G(G), .PRE(CLR), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_LDC_LVDS

module OBUFTDS_LDCE_LVDS (D,T,GE,G,CLR,O,OB);
input D, T, GE, G, CLR;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*") 
// set_dont_touch current_design
// set_attribute OBUFTDS_LDCE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p));
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n));
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_p));
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_LDCE_LVDS

module OBUFTDS_LDP_LVDS (D,T,G,PRE,O,OB);
input D, T, G, PRE;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute OBUFTDS_LDP_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
LDP olatch_p (.D(D),   .G(G), .PRE(PRE), .Q(q_p));
LDC olatch_n (.D(D_n), .G(G), .CLR(PRE), .Q(q_n));
LDP tri_p (.D(T),   .G(G), .PRE(PRE), .Q(t_p));
LDP tri_n (.D(T),   .G(G), .PRE(PRE), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_LDP_LVDS

module OBUFTDS_LDPE_LVDS (D,T,GE,G,PRE,O,OB);
input D, T, GE, G, PRE;
output O,OB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute OBUFTDS_LDPE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n;

INV  inv_n (.I(D), .O(D_n));
LDPE olatch_p (.D(D),   .GE(GE), .G(G), .PRE(PRE), .Q(q_p));
LDCE olatch_n (.D(D_n), .GE(GE), .G(G), .CLR(PRE), .Q(q_n));
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(PRE), .Q(t_p));
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(PRE), .Q(t_n));
OBUFT_LVDS pad_p (.I(q_p), .T(t_p), .O(O));
OBUFT_LVDS pad_n (.I(q_n), .T(t_n), .O(OB));

endmodule // OBUFTDS_LDPE_LVDS

// *********************************
// Start of the Input/Output Buffers
// IO Buffer Flipflops
// *********************************

module IOBUFDS_FD_LVDS (D,T,C,Q,IO,IOB);
input D, T, C;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FD_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n));
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p));
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n));
FDP tri_p (.D(T),   .C(C), .PRE(CLR), .Q(t_p));
FDP tri_n (.D(T),   .C(C), .PRE(CLR), .Q(t_n));
FDC iff_p (.D(i_p), .C(C), .CLR(CLR), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FD_LVDS

module IOBUFDS_FDE_LVDS (D,T,CE,C,Q,IO,IOB);
input D, T, CE, C;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FDE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n));
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p));
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n));
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_p));
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_n));
FDCE iff_p (.D(i_p), .CE(CE), .C(C), .CLR(CLR), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FDE_LVDS

module IOBUFDS_FDC_LVDS (D,T,C,CLR,Q,IO,IOB);
input D, T, C, CLR;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FDC_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p));
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n));
FDP tri_p (.D(T),   .C(C), .PRE(CLR), .Q(t_p));
FDP tri_n (.D(T),   .C(C), .PRE(CLR), .Q(t_n));
FDC iff_p (.D(i_p), .C(C), .CLR(CLR), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FDC_LVDS

module IOBUFDS_FDCE_LVDS (D,T,CE,C,CLR,Q,IO,IOB);
input D, T, CE, C, CLR;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FDCE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p));
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n));
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_p));
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_n));
FDCE iff_p (.D(i_p), .CE(CE), .C(C), .CLR(CLR), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FDCE_LVDS

module IOBUFDS_FDP_LVDS (D,T,C,PRE,Q,IO,IOB);
input D, T, C, PRE;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FDP_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
FDP off_p (.D(D),   .C(C), .PRE(PRE), .Q(q_p));
FDC off_n (.D(D_n), .C(C), .CLR(PRE), .Q(q_n));
FDP tri_p (.D(T),   .C(C), .PRE(PRE), .Q(t_p));
FDP tri_n (.D(T),   .C(C), .PRE(PRE), .Q(t_n));
FDP iff_p (.D(i_p), .C(C), .PRE(PRE), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FDP_LVDS

module IOBUFDS_FDPE_LVDS (D,T,CE,C,PRE,Q,IO,IOB);
input D, T, CE, C, PRE;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FDPE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
FDPE off_p (.D(D),   .CE(CE), .C(C), .PRE(PRE), .Q(q_p));
FDCE off_n (.D(D_n), .CE(CE), .C(C), .CLR(PRE), .Q(q_n));
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(PRE), .Q(t_p));
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(PRE), .Q(t_n));
FDPE iff_p (.D(i_p), .CE(CE), .C(C), .PRE(PRE), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FDPE_LVDS

module IOBUFDS_FDR_LVDS (D,T,C,R,Q,IO,IOB);
input D, T, C, R;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FDR_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
FDR off_p (.D(D),   .C(C), .R(R), .Q(q_p));
FDS off_n (.D(D_n), .C(C), .S(R), .Q(q_n));
FDS tri_p (.D(T),   .C(C), .S(R), .Q(t_p));
FDS tri_n (.D(T),   .C(C), .S(R), .Q(t_n));
FDR iff_p (.D(i_p), .C(C), .R(R), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FDR_LVDS

module IOBUFDS_FDRE_LVDS (D,T,CE,C,R,Q,IO,IOB);
input D, T, CE, C, R;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FDRE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
FDRE off_p (.D(D),   .CE(CE), .C(C), .R(R), .Q(q_p));
FDSE off_n (.D(D_n), .CE(CE), .C(C), .S(R), .Q(q_n));
FDSE tri_p (.D(T),   .CE(CE), .C(C), .S(R), .Q(t_p));
FDSE tri_n (.D(T),   .CE(CE), .C(C), .S(R), .Q(t_n));
FDRE iff_p (.D(i_p), .CE(CE), .C(C), .R(R), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FDRE_LVDS

module IOBUFDS_FDS_LVDS (D,T,C,S,Q,IO,IOB);
input D, T, C, S;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FDS_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
FDS off_p (.D(D),   .C(C), .S(S), .Q(q_p));
FDR off_n (.D(D_n), .C(C), .R(S), .Q(q_n));
FDS tri_p (.D(T),   .C(C), .S(S), .Q(t_p));
FDS tri_n (.D(T),   .C(C), .S(S), .Q(t_n));
FDS iff_p (.D(i_p), .C(C), .S(S), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FDS_LVDS

module IOBUFDS_FDSE_LVDS (D,T,CE,C,S,Q,IO,IOB);
input D, T, CE, C, S;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_FDSE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
FDSE off_p (.D(D),   .CE(CE), .C(C), .S(S), .Q(q_p));
FDRE off_n (.D(D_n), .CE(CE), .C(C), .R(S), .Q(q_n));
FDSE tri_p (.D(T),   .CE(CE), .C(C), .S(S), .Q(t_p));
FDSE tri_n (.D(T),   .CE(CE), .C(C), .S(S), .Q(t_n));
FDSE iff_p (.D(i_p), .CE(CE), .C(C), .S(S), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_FDSE_LVDS

// ***************
// IO Buffer Latch
// ***************
module IOBUFDS_LD_LVDS (D,T,G,Q,IO,IOB);
input D, T, G;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_LD_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n));
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p));
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n));
LDP tri_p (.D(T),   .G(G), .PRE(CLR), .Q(t_p));
LDP tri_n (.D(T),   .G(G), .PRE(CLR), .Q(t_n));
LDC ilatch_p (.D(i_p), .G(G), .CLR(CLR), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_LD_LVDS

module IOBUFDS_LDE_LVDS (D,T,GE,G,Q,IO,IOB);
input D, T, GE, G;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_LDE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n));
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p));
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n));
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_p));
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_n));
LDCE ilatch_p (.D(i_p), .GE(GE), .G(G), .CLR(CLR), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_LDE_LVDS

module IOBUFDS_LDC_LVDS (D,T,G,CLR,Q,IO,IOB);
input D, T, G, CLR;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_LDC_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p));
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n));
LDP tri_p (.D(T),   .G(G), .PRE(CLR), .Q(t_p));
LDP tri_n (.D(T),   .G(G), .PRE(CLR), .Q(t_n));
LDC ilatch_p (.D(i_p), .G(G), .CLR(CLR), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_LDC_LVDS

module IOBUFDS_LDCE_LVDS (D,T,GE,G,CLR,Q,IO,IOB);
input D, T, GE, G, CLR;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_LDCE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p));
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n));
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_p));
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_n));
LDCE ilatch_p (.D(i_p), .GE(GE), .G(G), .CLR(CLR), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_LDCE_LVDS

module IOBUFDS_LDP_LVDS (D,T,G,PRE,Q,IO,IOB);
input D, T, G, PRE;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_LDP_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
LDPE olatch_p (.D(D),   .G(G), .PRE(PRE), .Q(q_p));
LDCE olatch_n (.D(D_n), .G(G), .CLR(PRE), .Q(q_n));
LDPE tri_p (.D(T),   .G(G), .PRE(PRE), .Q(t_p));
LDPE tri_n (.D(T),   .G(G), .PRE(PRE), .Q(t_n));
LDPE ilatch_p (.D(i_p), .G(G), .PRE(PRE), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_LDP_LVDS

module IOBUFDS_LDPE_LVDS (D,T,GE,G,PRE,Q,IO,IOB);
input D, T, GE, G, PRE;
output Q;
inout IO,IOB;

// synopsys dc_script_begin
// set_dont_touch find(cell,"*")
// set_dont_touch current_design
// set_attribute IOBUFDS_LDPE_LVDS IOB "true" -type string
// synopsys dc_script_end
wire D_n,q_p,q_n,t_p,t_n,i_p;

INV  inv_n (.I(D), .O(D_n));
LDPE olatch_p (.D(D),   .GE(GE), .G(G), .PRE(PRE), .Q(q_p));
LDCE olatch_n (.D(D_n), .GE(GE), .G(G), .CLR(PRE), .Q(q_n));
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(PRE), .Q(t_p));
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(PRE), .Q(t_n));
LDPE ilatch_p (.D(i_p), .GE(GE), .G(G), .PRE(PRE), .Q(Q));
IOBUF_LVDS pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO));
IOBUF_LVDS pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB));

endmodule // IOBUFDS_LDPE_LVDS









