library ieee;
use ieee.std_logic_1164.all;

package lvpecl_macros is

  component IBUFDS_FD_LVPECL
    port (
      I, IB, C : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_FDE_LVPECL
    port (
      I, IB, CE, C : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_FDC_LVPECL
    port (
      I, IB, C, CLR : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_FDCE_LVPECL
    port (
      I, IB, CE, C, CLR : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_FDP_LVPECL
    port (
      I, IB, C, PRE : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_FDPE_LVPECL
    port (
      I, IB, CE, C, PRE : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_FDR_LVPECL
    port (
      I, IB, C, R : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_FDRE_LVPECL
    port (
      I, IB, CE, C, R : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_FDS_LVPECL
    port (
      I, IB, C, S : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_FDSE_LVPECL
    port (
      I, IB, CE, C, S : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_LD_LVPECL
    port (
      I, IB, G : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_LDE_LVPECL
    port (
      I, IB, GE, G : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_LDC_LVPECL
    port (
      I, IB, G, CLR : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_LDCE_LVPECL
    port (
      I, IB, GE, G, CLR : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_LDP_LVPECL
    port (
      I, IB, G, PRE : in std_logic;
      Q : out std_logic
      );
  end component;

  component IBUFDS_LDPE_LVPECL
    port (
      I, IB, GE, G, PRE : in std_logic;
      Q : out std_logic
      );
  end component;

  component OBUFDS_FD_LVPECL
    port (
      D, C : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_FDE_LVPECL
    port (
      D, CE, C : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_FDC_LVPECL
    port (
      D, C, CLR : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_FDCE_LVPECL
    port (
      D, CE, C, CLR : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_FDP_LVPECL
    port (
      D, C, PRE : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_FDPE_LVPECL
    port (
      D, CE, C, PRE : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_FDR_LVPECL
    port (
      D, C, R : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_FDRE_LVPECL
    port (
      D, CE, C, R : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_FDS_LVPECL
    port (
      D, C, S : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_FDSE_LVPECL
    port (
      D, CE, C, S : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_LD_LVPECL
    port (
      D, G : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_LDE_LVPECL
    port (
      D, GE, G : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_LDC_LVPECL
    port (
      D, G, CLR : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_LDCE_LVPECL
    port (
      D, GE, G, CLR : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_LDP_LVPECL
    port (
      D, G, PRE : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFDS_LDPE_LVPECL
    port (
      D, GE, G, PRE : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FD_LVPECL
    port (
      D, T, C : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FDE_LVPECL
    port (
      D, T, CE, C : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FDC_LVPECL
    port (
      D, T, C, CLR : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FDCE_LVPECL
    port (
      D, T, CE, C, CLR : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FDP_LVPECL
    port (
      D, T, C, PRE : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FDPE_LVPECL
    port (
      D, T, CE, C, PRE : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FDR_LVPECL
    port (
      D, T, C, R : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FDRE_LVPECL
    port (
      D, T, CE, C, R : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FDS_LVPECL
    port (
      D, T, C, S : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_FDSE_LVPECL
    port (
      D, T, CE, C, S : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_LD_LVPECL
    port (
      D, T, G : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_LDE_LVPECL
    port (
      D, T, GE, G : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_LDC_LVPECL
    port (
      D, T, G, CLR : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_LDCE_LVPECL
    port (
      D, T, GE, G, CLR : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_LDP_LVPECL
    port (
      D, T, G, PRE : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component OBUFTDS_LDPE_LVPECL
    port (
      D, T, GE, G, PRE : in std_logic;
      O, OB : out std_logic
      );
  end component;

  component IOBUFDS_FD_LVPECL
    port (
      D, T, C : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_FDE_LVPECL
    port (
      D, T, CE, C : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_FDC_LVPECL
    port (
      D, T, C, CLR : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_FDCE_LVPECL
    port (
      D, T, CE, C, CLR : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_FDP_LVPECL
    port (
      D, T, C, PRE : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_FDPE_LVPECL
    port (
      D, T, CE, C, PRE : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_FDR_LVPECL
    port (
      D, T, C, R : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_FDRE_LVPECL
    port (
      D, T, CE, C, R : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_FDS_LVPECL
    port (
      D, T, C, S : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_FDSE_LVPECL
    port (
      D, T, CE, C, S : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_LD_LVPECL
    port (
      D, T, G : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_LDE_LVPECL
    port (
      D, T, GE, G : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_LDC_LVPECL
    port (
      D, T, G, CLR : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_LDCE_LVPECL
    port (
      D, T, GE, G, CLR : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_LDP_LVPECL
    port (
      D, T, G, PRE : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component;

  component IOBUFDS_LDPE_LVPECL
    port (
      D, T, GE, G, PRE : in std_logic;
      Q : out std_logic;
      IO, IOB : inout std_logic
      );
  end component ;

end lvpecl_macros;
