-- **************************
-- Start of the Input Buffers
-- Input Flip Flops  
-- **************************

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FD_LVPECL is
  port (
    I, IB, C : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FD_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FD_lvpecl is
  -- synopsys dc_script_begin
  -- set_dont_touch find(cell,"*")
  -- set_dont_touch current_design
  -- set_attribute iff_p IOB "true" -type string
  -- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FD port map (D => I_w, C => C, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);   
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w); 
end lvpecl_buff0; -- IBUFDS_FD_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FDE_LVPECL is
  port (
    I, IB, CE, C : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FDE_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FDE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FDE port map (D => I_w, CE => CE, C => C, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_FDE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FDC_LVPECL is
  port (
    I, IB, C, CLR : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FDC_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FDC_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FDC port map (D => I_w, C => C, CLR => CLR, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_FDC_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FDCE_LVPECL is
  port (
    I, IB, CE, C, CLR : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FDCE_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FDCE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FDCE port map (D => I_w, CE => CE, C => C, CLR => CLR, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_FDCE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FDP_LVPECL is
  port (
    I, IB, C, PRE : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FDP_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FDP_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FDP port map (D => I_w, C => C, PRE => PRE, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_FDP_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FDPE_LVPECL is
  port (
    I, IB, CE, C, PRE : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FDPE_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FDPE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FDPE port map (D => I_w, CE => CE, C => C, PRE => PRE, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_FDPE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FDR_LVPECL is
  port (
    I, IB, C, R : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FDR_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FDR_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FDR port map (D => I_w, C => C, R => R, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_FDR_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FDRE_LVPECL is
  port (
    I, IB, CE, C, R : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FDRE_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FDRE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FDRE port map (D => I_w, CE => CE, C => C, R => R, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_FDRE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FDS_LVPECL is
  port (
    I, IB, C, S : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FDS_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FDS_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FDS port map (D => I_w, C => C, S => S, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_FDS_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_FDSE_LVPECL is
  port (
    I, IB, CE, C, S : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_FDSE_LVPECL;

architecture lvpecl_buff0 of IBUFDS_FDSE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  iff_p : FDSE port map (D => I_w, CE => CE, C => C, S => S, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_FDSE_lvpecl

-- *************
-- Input Latches
-- *************
library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_LD_LVPECL is
  port (
    I, IB, G : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_LD_LVPECL;

architecture lvpecl_buff0 of IBUFDS_LD_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  ilatch_p : LD port map (D => I_w, G => G, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_LD_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_LDE_LVPECL is
  port (
    I, IB, GE, G : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_LDE_LVPECL;

architecture lvpecl_buff0 of IBUFDS_LDE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  ilatch_p : LDE port map (D => I_w, GE => GE, G => G, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_LDE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_LDC_LVPECL is
  port (
    I, IB, G, CLR : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_LDC_LVPECL;

architecture lvpecl_buff0 of IBUFDS_LDC_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  ilatch_p : LDC port map (D => I_w, G => G, CLR => CLR, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_LDC_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_LDCE_LVPECL is
  port (
    I, IB, GE, G, CLR : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_LDCE_LVPECL;

architecture lvpecl_buff0 of IBUFDS_LDCE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  ilatch_p : LDCE port map (D => I_w, GE => GE, G => G, CLR => CLR, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_LDCE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_LDP_LVPECL is
  port (
    I, IB, G, PRE : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_LDP_LVPECL;

architecture lvpecl_buff0 of IBUFDS_LDP_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  ilatch_p : LDP port map (D => I_w, G => G, PRE => PRE, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_LDP_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IBUFDS_LDPE_LVPECL is
  port (
    I, IB, GE, G, PRE : in std_logic;
    Q : out std_logic
  );
end entity IBUFDS_LDPE_LVPECL;

architecture lvpecl_buff0 of IBUFDS_LDPE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal I_w, IB_w : std_logic;
begin
  ilatch_p : LDPE port map (D => I_w, GE => GE, G => G, PRE => PRE, Q => Q);
  pad_p : IBUF_LVPECL port map (I => I, O => I_w);
  pad_n : IBUF_LVPECL port map (I => IB, O => IB_w);
end lvpecl_buff0; -- IBUFDS_LDPE_lvpecl

-- ***************************
-- Start of the Output Buffers
-- Output Flipflops
-- ***************************

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FD_LVPECL is
  port (
    D, C : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FD_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FD_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDC port map (D => D, C => C, CLR => CLR, Q => q_p);
  off_n : FDP port map (D => D_n, C => C, PRE => CLR, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FD_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FDE_LVPECL is
  port (
    D, CE, C : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FDE_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FDE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDCE port map (D => D, CE => CE, C => C, CLR => CLR, Q => q_p);
  off_n : FDPE port map (D => D_n, CE => CE, C => C, PRE => CLR, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FDE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FDC_LVPECL is
  port (
    D, C, CLR : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FDC_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FDC_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDC port map (D => D, C => C, CLR => CLR, Q => q_p);
  off_n : FDP port map (D => D_n, C => C, PRE => CLR, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FDC_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FDCE_LVPECL is
  port (
    D, CE, C, CLR : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FDCE_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FDCE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDCE port map (D => D, CE => CE, C => C, CLR => CLR, Q => q_p);
  off_n : FDPE port map (D => D_n, CE => CE, C => C, PRE => CLR, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FDCE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FDP_LVPECL is
  port (
    D, C, PRE : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FDP_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FDP_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDP port map (D => D, C => C, PRE => PRE, Q => q_p);
  off_n : FDC port map (D => D_n, C => C, CLR => PRE, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FDP_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FDPE_LVPECL is
  port (
    D, CE, C, PRE : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FDPE_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FDPE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDPE port map (D => D, CE => CE, C => C, PRE => PRE, Q => q_p);
  off_n : FDCE port map (D => D_n, CE => CE, C => C, CLR => PRE, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FDPE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FDR_LVPECL is
  port (
    D, C, R : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FDR_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FDR_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDR port map (D => D, C => C, R => R, Q => q_p);
  off_n : FDS port map (D => D_n, C => C, S => R, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FDR_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FDRE_LVPECL is
  port (
    D, CE, C, R : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FDRE_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FDRE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDRE port map (D => D, CE => CE, C => C, R => R, Q => q_p);
  off_n : FDSE port map (D => D_n, CE => CE, C => C, S => R, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FDRE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FDS_LVPECL is
  port (
    D, C, S : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FDS_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FDS_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDS port map (D => D, C => C, S => S, Q => q_p);
  off_n : FDR port map (D => D_n, C => C, R => S, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FDS_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_FDSE_LVPECL is
  port (
    D, CE, C, S : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_FDSE_LVPECL;

architecture lvpecl_buff0 of OBUFDS_FDSE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDSE port map (D => D, CE => CE, C => C, S => S, Q => q_p);
  off_n : FDRE port map (D => D_n, CE => CE, C => C, R => S, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_FDSE_lvpecl

-- **************
-- Output Latches
-- **************

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_LD_LVPECL is
  port (
    D, G : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_LD_LVPECL;

architecture lvpecl_buff0 of OBUFDS_LD_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDC port map (D => D, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDP port map (D => D_n, G => G, PRE => CLR, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_LD_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_LDE_LVPECL is
  port (
    D, GE, G : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_LDE_LVPECL;

architecture lvpecl_buff0 of OBUFDS_LDE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDCE port map (D => D, GE => GE, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDPE port map (D => D_n, GE => GE, G => G, PRE => CLR, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_LDE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_LDC_LVPECL is
  port (
    D, G, CLR : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_LDC_LVPECL;

architecture lvpecl_buff0 of OBUFDS_LDC_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDC port map (D => D, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDP port map (D => D_n, G => G, PRE => CLR, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_LDC_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_LDCE_LVPECL is
  port (
    D, GE, G, CLR : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_LDCE_LVPECL;

architecture lvpecl_buff0 of OBUFDS_LDCE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDCE port map (D => D, GE => GE, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDPE port map (D => D_n, GE => GE, G => G, PRE => CLR, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_LDCE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_LDP_LVPECL is
  port (
    D, G, PRE : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_LDP_LVPECL;

architecture lvpecl_buff0 of OBUFDS_LDP_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDP port map (D => D, G => G, PRE => PRE, Q => q_p);
  olatch_n : LDC port map (D => D_n, G => G, CLR => PRE, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_LDP_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFDS_LDPE_LVPECL is
  port (
    D, GE, G, PRE : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFDS_LDPE_LVPECL;

architecture lvpecl_buff0 of OBUFDS_LDPE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDPE port map (D => D, GE => GE, G => G, PRE => PRE, Q => q_p);
  olatch_n : LDCE port map (D => D_n, GE => GE, G => G, CLR => PRE, Q => q_n);
  pad_p : OBUF_LVPECL port map (I => q_p , O => O);
  pad_n : OBUF_LVPECL port map (I => q_n, O => OB);
end lvpecl_buff0; -- OBUFDS_LDPE_lvpecl


-- *************************************
-- Start of the Tri-State Output Buffers
-- Tri-state output flipflops
-- *************************************

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FD_LVPECL is
  port (
    D, T, C : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FD_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FD_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDC port map (D => D, C => C, CLR => CLR, Q => q_p);
  off_n : FDP port map (D => D_n, C => C, PRE => CLR, Q => q_n);
  tri_p : FDP port map (D => T, C => C, PRE => CLR, Q => t_p);
  tri_n : FDP port map (D => T, C => C, PRE => CLR, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FD_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FDE_LVPECL is
  port (
    D, T, CE, C : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FDE_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FDE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDCE port map (D => D, CE => CE, C => C, CLR => CLR, Q => q_p);
  off_n : FDPE port map (D => D_n, CE => CE, C => C, PRE => CLR, Q => q_n);
  tri_p : FDPE port map (D => T, CE => CE, C => C, PRE => CLR, Q => t_p);
  tri_n : FDPE port map (D => T, CE => CE, C => C, PRE => CLR, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FDE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FDC_LVPECL is
  port (
    D, T, C, CLR : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FDC_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FDC_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDC port map (D => D, C => C, CLR => CLR, Q => q_p);
  off_n : FDP port map (D => D_n, C => C, PRE => CLR, Q => q_n);
  tri_p : FDP port map (D => T, C => C, PRE => CLR, Q => t_p);
  tri_n : FDP port map (D => T, C => C, PRE => CLR, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FDC_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FDCE_LVPECL is
  port (
    D, T, CE, C, CLR : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FDCE_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FDCE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDCE port map (D => D, CE => CE, C => C, CLR => CLR, Q => q_p);
  off_n : FDPE port map (D => D_n, CE => CE, C => C, PRE => CLR, Q => q_n);
  tri_p : FDPE port map (D => T, CE => CE, C => C, PRE => CLR, Q => t_p);
  tri_n : FDPE port map (D => T, CE => CE, C => C, PRE => CLR, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FDCE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FDP_LVPECL is
  port (
    D, T, C, PRE : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FDP_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FDP_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDP port map (D => D, C => C, PRE => PRE, Q => q_p);
  off_n : FDC port map (D => D_n, C => C, CLR => PRE, Q => q_n);
  tri_p : FDP port map (D => T, C => C, PRE => PRE, Q => t_p);
  tri_n : FDP port map (D => T, C => C, PRE => PRE, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FDP_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FDPE_LVPECL is
  port (
    D, T, CE, C, PRE : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FDPE_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FDPE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDPE port map (D => D, CE => CE, C => C, PRE => PRE, Q => q_p);
  off_n : FDCE port map (D => D_n, CE => CE, C => C, CLR => PRE, Q => q_n);
  tri_p : FDPE port map (D => T, CE => CE, C => C, PRE => PRE, Q => t_p);
  tri_n : FDPE port map (D => T, CE => CE, C => C, PRE => PRE, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FDPE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FDR_LVPECL is
  port (
    D, T, C, R : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FDR_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FDR_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDR port map (D => D, C => C, R => R, Q => q_p);
  off_n : FDS port map (D => D_n, C => C, S => R, Q => q_n);
  tri_p : FDS port map (D => T, C => C, S => R, Q => t_p);
  tri_n : FDS port map (D => T, C => C, S => R, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FDR_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FDRE_LVPECL is
  port (
    D, T, CE, C, R : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FDRE_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FDRE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDRE port map (D => D, CE => CE, C => C, R => R, Q => q_p);
  off_n : FDSE port map (D => D_n, CE => CE, C => C, S => R, Q => q_n);
  tri_p : FDSE port map (D => T, CE => CE, C => C, S => R, Q => t_p);
  tri_n : FDSE port map (D => T, CE => CE, C => C, S => R, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FDRE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FDS_LVPECL is
  port (
    D, T, C, S : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FDS_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FDS_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDS port map (D => D, C => C, S => S, Q => q_p);
  off_n : FDR port map (D => D_n, C => C, R => S, Q => q_n);
  tri_p : FDS port map (D => T, C => C, S => S, Q => t_p);
  tri_n : FDS port map (D => T, C => C, S => S, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FDS_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_FDSE_LVPECL is
  port (
    D, T, CE, C, S : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_FDSE_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_FDSE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDSE port map (D => D, CE => CE, C => C, S => S, Q => q_p);
  off_n : FDRE port map (D => D_n, CE => CE, C => C, R => S, Q => q_n);
  tri_p : FDSE port map (D => T, CE => CE, C => C, S => S, Q => t_p);
  tri_n : FDSE port map (D => T, CE => CE, C => C, S => S, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_FDSE_lvpecl

-- ************************
-- Tri-state output latches
-- ************************

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_LD_LVPECL is
  port (
    D, T, G : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_LD_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_LD_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDC port map (D => D, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDP port map (D => D_n, G => G, PRE => CLR, Q => q_n);
  tri_p : LDP port map (D => T, G => G, PRE => CLR, Q => t_p);
  tri_n : LDP port map (D => T, G => G, PRE => CLR, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_LD_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_LDE_LVPECL is
  port (
    D, T, GE, G : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_LDE_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_LDE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDCE port map (D => D, GE => GE, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDPE port map (D => D_n, GE => GE, G => G, PRE => CLR, Q => q_n);
  tri_p : LDPE port map (D => T, GE => GE, G => G, PRE => CLR, Q => t_p);
  tri_n : LDPE port map (D => T, GE => GE, G => G, PRE => CLR, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_LDE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_LDC_LVPECL is
  port (
    D, T, G, CLR : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_LDC_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_LDC_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDC port map (D => D, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDP port map (D => D_n, G => G, PRE => CLR, Q => q_n);
  tri_p : LDP port map (D => T, G => G, PRE => CLR, Q => t_p);
  tri_n : LDP port map (D => T, G => G, PRE => CLR, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_LDC_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_LDCE_LVPECL is
  port (
    D, T, GE, G, CLR : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_LDCE_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_LDCE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDCE port map (D => D, GE => GE, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDPE port map (D => D_n, GE => GE, G => G, PRE => CLR, Q => q_n);
  tri_p : LDPE port map (D => T, GE => GE, G => G, PRE => CLR, Q => t_p);
  tri_n : LDPE port map (D => T, GE => GE, G => G, PRE => CLR, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_LDCE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_LDP_LVPECL is
  port (
    D, T, G, PRE : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_LDP_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_LDP_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDP port map (D => D, G => G, PRE => PRE, Q => q_p);
  olatch_n : LDC port map (D => D_n, G => G, CLR => PRE, Q => q_n);
  tri_p : LDP port map (D => T, G => G, PRE => PRE, Q => t_p);
  tri_n : LDP port map (D => T, G => G, PRE => PRE, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_LDP_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity OBUFTDS_LDPE_LVPECL is
  port (
    D, T, GE, G, PRE : in std_logic;
    O, OB : out std_logic
  );
end entity OBUFTDS_LDPE_LVPECL;

architecture lvpecl_buff0 of OBUFTDS_LDPE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- synopsys dc_script_end
  signal D_n, q_n, q_p, t_p, t_n : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDPE port map (D => D, GE => GE, G => G, PRE => PRE, Q => q_p);
  olatch_n : LDCE port map (D => D_n, GE => GE, G => G, CLR => PRE, Q => q_n);
  tri_p : LDPE port map (D => T, GE => GE, G => G, PRE => PRE, Q => t_p);
  tri_n : LDPE port map (D => T, GE => GE, G => G, PRE => PRE, Q => t_n);
  pad_p : OBUFT_LVPECL port map (I => q_p, T => t_p, O => O);
  pad_n : OBUFT_LVPECL port map (I => q_n, T => t_n, O => OB);
end lvpecl_buff0; -- OBUFTDS_LDPE_lvpecl

-- *********************************
-- Start of the Input/Output Buffers
-- IO Buffer Flipflops
-- *********************************

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FD_LVPECL is
  port (
    D, T, C : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FD_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FD_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDC port map (D => D, C => C, CLR => CLR, Q => q_p);
  off_n : FDP port map (D => D_n, C => C, PRE => CLR, Q => q_n);
  tri_p : FDP port map (D => T, C => C, PRE => CLR, Q => t_p);
  tri_n : FDP port map (D => T, C => C, PRE => CLR, Q => t_n);
  iff_p : FD port map (D => i_p, C => C, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FD_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FDE_LVPECL is
  port (
    D, T, CE, C : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FDE_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FDE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDCE port map (D => D, CE => CE, C => C, CLR => CLR, Q => q_p);
  off_n : FDPE port map (D => D_n, CE => CE, C => C, PRE => CLR, Q => q_n);
  tri_p : FDPE port map (D => T, CE => CE, C => C, PRE => CLR, Q => t_p);
  tri_n : FDPE port map (D => T, CE => CE, C => C, PRE => CLR, Q => t_n);
  iff_p : FDE port map (D => i_p, CE => CE, C => C, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FDE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FDC_LVPECL is
  port (
    D, T, C, CLR : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FDC_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FDC_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDC port map (D => D, C => C, CLR => CLR, Q => q_p);
  off_n : FDP port map (D => D_n, C => C, PRE => CLR, Q => q_n);
  tri_p : FDP port map (D => T, C => C, PRE => CLR, Q => t_p);
  tri_n : FDP port map (D => T, C => C, PRE => CLR, Q => t_n);
  iff_p : FDC port map (D => i_p, C => C, CLR => CLR, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FDC_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FDCE_LVPECL is
  port (
    D, T, CE, C, CLR : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FDCE_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FDCE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDCE port map (D => D, CE => CE, C => C, CLR => CLR, Q => q_p);
  off_n : FDPE port map (D => D_n, CE => CE, C => C, PRE => CLR, Q => q_n);
  tri_p : FDPE port map (D => T, CE => CE, C => C, PRE => CLR, Q => t_p);
  tri_n : FDPE port map (D => T, CE => CE, C => C, PRE => CLR, Q => t_n);
  iff_p : FDCE port map (D => i_p, CE => CE, C => C, CLR => CLR, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FDCE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FDP_LVPECL is
  port (
    D, T, C, PRE : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FDP_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FDP_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDP port map (D => D, C => C, PRE => PRE, Q => q_p);
  off_n : FDC port map (D => D_n, C => C, CLR => PRE, Q => q_n);
  tri_p : FDP port map (D => T, C => C, PRE => PRE, Q => t_p);
  tri_n : FDP port map (D => T, C => C, PRE => PRE, Q => t_n);
  iff_p : FDP port map (D => i_p, C => C, PRE => PRE, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FDP_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FDPE_LVPECL is
  port (
    D, T, CE, C, PRE : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FDPE_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FDPE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDPE port map (D => D, CE => CE, C => C, PRE => PRE, Q => q_p);
  off_n : FDCE port map (D => D_n, CE => CE, C => C, CLR => PRE, Q => q_n);
  tri_p : FDPE port map (D => T, CE => CE, C => C, PRE => PRE, Q => t_p);
  tri_n : FDPE port map (D => T, CE => CE, C => C, PRE => PRE, Q => t_n);
  iff_p : FDPE port map (D => i_p, CE => CE, C => C, PRE => PRE, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FDPE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FDR_LVPECL is
  port (
    D, T, C, R : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FDR_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FDR_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDR port map (D => D, C => C, R => R, Q => q_p);
  off_n : FDS port map (D => D_n, C => C, S => R, Q => q_n);
  tri_p : FDS port map (D => T, C => C, S => R, Q => t_p);
  tri_n : FDS port map (D => T, C => C, S => R, Q => t_n);
  iff_p : FDR port map (D => i_p, C => C, R => R, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FDR_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FDRE_LVPECL is
  port (
    D, T, CE, C, R : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FDRE_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FDRE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDRE port map (D => D, CE => CE, C => C, R => R, Q => q_p);
  off_n : FDSE port map (D => D_n, CE => CE, C => C, S => R, Q => q_n);
  tri_p : FDSE port map (D => T, CE => CE, C => C, S => R, Q => t_p);
  tri_n : FDSE port map (D => T, CE => CE, C => C, S => R, Q => t_n);
  iff_p : FDRE port map (D => i_p, CE => CE, C => C, R => R, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FDRE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FDS_LVPECL is
  port (
    D, T, C, S : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FDS_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FDS_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDS port map (D => D, C => C, S => S, Q => q_p);
  off_n : FDR port map (D => D_n, C => C, R => S, Q => q_n);
  tri_p : FDS port map (D => T, C => C, S => S, Q => t_p);
  tri_n : FDS port map (D => T, C => C, S => S, Q => t_n);
  iff_p : FDS port map (D => i_p, C => C, S => S, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FDS_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_FDSE_LVPECL is
  port (
    D, T, CE, C, S : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_FDSE_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_FDSE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute off_p IOB "true" -type string
-- set_attribute off_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute iff_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  off_p : FDSE port map (D => D, CE => CE, C => C, S => S, Q => q_p);
  off_n : FDRE port map (D => D_n, CE => CE, C => C, R => S, Q => q_n);
  tri_p : FDSE port map (D => T, CE => CE, C => C, S => S, Q => t_p);
  tri_n : FDSE port map (D => T, CE => CE, C => C, S => S, Q => t_n);
  iff_p : FDSE port map (D => i_p, CE => CE, C => C, S => S, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_FDSE_lvpecl

-- ***************
-- IO Buffer Latch
-- ***************

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_LD_LVPECL is
  port (
    D, T, G : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_LD_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_LD_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDC port map (D => D, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDP port map (D => D_n, G => G, PRE => CLR, Q => q_n);
  tri_p : LDP port map (D => T, G => G, PRE => CLR, Q => t_p);
  tri_n : LDP port map (D => T, G => G, PRE => CLR, Q => t_n);
  ilatch_p : LD port map (D => i_p, G => G, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_LD_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_LDE_LVPECL is
  port (
    D, T, GE, G : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_LDE_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_LDE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p, CLR : std_logic;
begin
  CLR <= '0';
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDCE port map (D => D, GE => GE, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDPE port map (D => D_n, GE => GE, G => G, PRE => CLR, Q => q_n);
  tri_p : LDPE port map (D => T, GE => GE, G => G, PRE => CLR, Q => t_p);
  tri_n : LDPE port map (D => T, GE => GE, G => G, PRE => CLR, Q => t_n);
  ilatch_p : LDE port map (D => i_p, GE => GE, G => G, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_LDE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_LDC_LVPECL is
  port (
    D, T, G, CLR : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_LDC_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_LDC_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDC port map (D => D, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDP port map (D => D_n, G => G, PRE => CLR, Q => q_n);
  tri_p : LDP port map (D => T, G => G, PRE => CLR, Q => t_p);
  tri_n : LDP port map (D => T, G => G, PRE => CLR, Q => t_n);
  ilatch_p : LDC port map (D => i_p, G => G, CLR => CLR, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_LDC_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_LDCE_LVPECL is
  port (
    D, T, GE, G, CLR : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_LDCE_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_LDCE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDCE port map (D => D, GE => GE, G => G, CLR => CLR, Q => q_p);
  olatch_n : LDPE port map (D => D_n, GE => GE, G => G, PRE => CLR, Q => q_n);
  tri_p : LDPE port map (D => T, GE => GE, G => G, PRE => CLR, Q => t_p);
  tri_n : LDPE port map (D => T, GE => GE, G => G, PRE => CLR, Q => t_n);
  ilatch_p : LDCE port map (D => i_p, GE => GE, G => G, CLR => CLR, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_LDCE_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_LDP_LVPECL is
  port (
    D, T, G, PRE : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_LDP_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_LDP_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDP port map (D => D, G => G, PRE => PRE, Q => q_p);
  olatch_n : LDC port map (D => D_n, G => G, CLR => PRE, Q => q_n);
  tri_p : LDP port map (D => T, G => G, PRE => PRE, Q => t_p);
  tri_n : LDP port map (D => T, G => G, PRE => PRE, Q => t_n);
  ilatch_p : LDP port map (D => i_p, G => G, PRE => PRE, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_LDP_lvpecl

library ieee;
use ieee.std_logic_1164.all;
library unisim;
use unisim.vcomponents.all;

entity IOBUFDS_LDPE_LVPECL is
  port (
    D, T, GE, G, PRE : in std_logic;
    Q : out std_logic;
    IO, IOB : inout std_logic
  );
end entity IOBUFDS_LDPE_LVPECL;

architecture lvpecl_buff0 of IOBUFDS_LDPE_lvpecl is
-- synopsys dc_script_begin
-- set_dont_touch find(cell,"*")
-- set_dont_touch current_design
-- set_attribute olatch_p IOB "true" -type string
-- set_attribute olatch_n IOB "true" -type string
-- set_attribute tri_p IOB "true" -type string
-- set_attribute tri_n IOB "true" -type string
-- set_attribute ilatch_p IOB "true" -type string
-- synopsys dc_script_end
  signal dummy_o, D_n, q_n, q_p, t_p, t_n, i_p : std_logic;
begin
  inv_n : INV port map (I => D, O => D_n);
  olatch_p : LDPE port map (D => D, GE => GE, G => G, PRE => PRE, Q => q_p);
  olatch_n : LDCE port map (D => D_n, GE => GE, G => G, CLR => PRE, Q => q_n);
  tri_p : LDPE port map (D => T, GE => GE, G => G, PRE => PRE, Q => t_p);
  tri_n : LDPE port map (D => T, GE => GE, G => G, PRE => PRE, Q => t_n);
  ilatch_p : LDPE port map (D => i_p, GE => GE, G => G, PRE => PRE, Q => Q);
  pad_p : IOBUF_LVPECL port map (I => q_p, T => t_p, O => i_p, IO => IO);
  pad_n : IOBUF_LVPECL port map (I => q_n, T => t_n, O => dummy_o, IO => IOB);
end lvpecl_buff0; -- IOBUFDS_LDPE_lvpecl




