// **************************
// Start of the Input Buffers
// Input Flip Flops  
// **************************

module IBUFDS_FD_LVPECL (I,IB,C,Q);
input I, IB, C;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FD off_p (.D(I_w), .C(C), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;
endmodule // IBUFDS_FD_LVPECL

module IBUFDS_FDE_LVPECL (I,IB,CE,C,Q);
input I, IB, CE, C;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FDE off_p (.D(I_w), .CE(CE), .C(C), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_FDE_LVPECL 

module IBUFDS_FDC_LVPECL (I,IB,C,CLR,Q);
input I, IB, C, CLR;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FDC off_p (.D(I_w), .C(C), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_FDC_LVPECL 

module IBUFDS_FDCE_LVPECL (I,IB,CE,C,CLR,Q);
input I, IB, CE, C, CLR;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FDCE off_p (.D(I_w), .CE(CE), .C(C), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_FDCE_LVPECL

module IBUFDS_FDP_LVPECL (I,IB,C,PRE,Q);
input I, IB, C, PRE;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FDP off_p (.D(I_w), .C(C), .PRE(PRE), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_FDP_LVPECL

module IBUFDS_FDPE_LVPECL (I,IB,CE,C,PRE,Q);
input I, IB, CE, C, PRE;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FDPE off_p (.D(I_w),   .CE(CE), .C(C), .PRE(PRE), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_FDPE_LVPECL

module IBUFDS_FDR_LVPECL (I,IB,C,R,Q);
input I, IB, C, R;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FDR off_p (.D(I_w), .C(C), .R(R), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_FDR_LVPECL

module IBUFDS_FDRE_LVPECL (I,IB,CE,C,R,Q);
input I, IB, CE, C, R;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FDRE off_p (.D(I_w),   .CE(CE), .C(C), .R(R), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_FDRE_LVPECL

module IBUFDS_FDS_LVPECL (I,IB,C,S,Q);
input I, IB, C, S;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FDS off_p (.D(I_w), .C(C), .S(S), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_FDS_LVPECL

module IBUFDS_FDSE_LVPECL (I,IB,CE,C,S,Q);
input I, IB, CE, C, S;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

FDSE off_p (.D(I_w),   .CE(CE), .C(C), .S(S), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_FDSE_LVPECL

// *************
// Input Latches
// *************
module IBUFDS_LD_LVPECL (I,IB,G,Q);
input I, IB, G;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

LD olatch_p (.D(I_w), .G(G), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_LD_LVPECL

module IBUFDS_LDE_LVPECL (I,IB,GE,G,Q);
input I, IB, GE, G;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

LDE olatch_p (.D(I_w), .GE(GE), .G(G), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_LDE_LVPECL 

module IBUFDS_LDC_LVPECL (I,IB,G,CLR,Q);
input I, IB, G, CLR;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

LDC olatch_p (.D(I_w), .G(G), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_LDC_LVPECL 

module IBUFDS_LDCE_LVPECL (I,IB,GE,G,CLR,Q);
input I, IB, GE, G, CLR;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

LDCE olatch_p (.D(I_w), .GE(GE), .G(G), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_LDCE_LVPECL

module IBUFDS_LDP_LVPECL (I,IB,G,PRE,Q);
input I, IB, G, PRE;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

LDP olatch_p (.D(I_w), .G(G), .PRE(PRE), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_LDP_LVPECL

module IBUFDS_LDPE_LVPECL (I,IB,GE,G,PRE,Q);
input I, IB, GE, G, PRE;
output Q;

wire I_w, IB_w /* synthesis syn_keep = 1 */ ;

LDPE olatch_p (.D(I_w),   .GE(GE), .G(G), .PRE(PRE), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IBUF_LVPECL pad_p (.I(I),  .O(I_w)) /* synthesis syn_noprune = 1 */ ;
IBUF_LVPECL pad_n (.I(IB), .O(IB_w)) /* synthesis syn_noprune = 1 */ ;

endmodule // IBUFDS_LDPE_LVPECL

// ***************************
// Start of the Output Buffers
// Output Flipflops
// ***************************

module OBUFDS_FD_LVPECL (D,C,O,OB);
input D, C;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;
wire CLR = 0; // Used to ensure that p and n are opposite on reset

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDC off_p (.D(D), .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FD_LVPECL

module OBUFDS_FDE_LVPECL (D,CE,C,O,OB);
input D, CE, C;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;
wire CLR = 0; // Used to ensure that p and n are opposite on reset

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FDE_LVPECL

module OBUFDS_FDC_LVPECL (D,C,CLR,O,OB);
input D, C, CLR;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FDC_LVPECL

module OBUFDS_FDCE_LVPECL (D,CE,C,CLR,O,OB);
input D, CE, C, CLR;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FDCE_LVPECL

module OBUFDS_FDP_LVPECL (D,C,PRE,O,OB);
input D, C, PRE;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDP off_p (.D(D),   .C(C), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDC off_n (.D(D_n), .C(C), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FDP_LVPECL

module OBUFDS_FDPE_LVPECL (D,CE,C,PRE,O,OB);
input D, CE, C, PRE;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDPE off_p (.D(D),   .CE(CE), .C(C), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDCE off_n (.D(D_n), .CE(CE), .C(C), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FDPE_LVPECL

module OBUFDS_FDR_LVPECL (D,C,R,O,OB);
input D, C, R;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDR off_p (.D(D),   .C(C), .R(R), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS off_n (.D(D_n), .C(C), .S(R), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FDR_LVPECL

module OBUFDS_FDRE_LVPECL (D,CE,C,R,O,OB);
input D, CE, C, R;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDRE off_p (.D(D),   .CE(CE), .C(C), .R(R), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE off_n (.D(D_n), .CE(CE), .C(C), .S(R), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FDRE_LVPECL

module OBUFDS_FDS_LVPECL (D,C,S,O,OB);
input D, C, S;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDS off_p (.D(D),   .C(C), .S(S), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDR off_n (.D(D_n), .C(C), .R(S), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FDS_LVPECL

module OBUFDS_FDSE_LVPECL (D,CE,C,S,O,OB);
input D, CE, C, S;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDSE off_p (.D(D),   .CE(CE), .C(C), .S(S), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDRE off_n (.D(D_n), .CE(CE), .C(C), .R(S), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_FDSE_LVPECL

// **************
// Output Latches
// **************

module OBUFDS_LD_LVPECL (D,G,O,OB);
input D, G;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;
wire CLR = 0; // Used to ensure that p and n are opposite on reset

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDC olatch_p (.D(D), .G(G), .CLR(CLR), .Q(q_p));   
			/* synthesis syn_noprune = 1 IOB = true */ ;
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_LD_LVPECL

module OBUFDS_LDE_LVPECL (D,GE,G,O,OB);
input D, GE, G;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;
wire CLR = 0; // Used to ensure that p and n are opposite on reset

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_LDE_LVPECL

module OBUFDS_LDC_LVPECL (D,G,CLR,O,OB);
input D, G, CLR;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_LDC_LVPECL

module OBUFDS_LDCE_LVPECL (D,GE,G,CLR,O,OB);
input D, GE, G, CLR;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_LDCE_LVPECL

module OBUFDS_LDP_LVPECL (D,G,PRE,O,OB);
input D, G, PRE;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDP olatch_p (.D(D),   .G(G), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDC olatch_n (.D(D_n), .G(G), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFDS_LDP_LVPECL

module OBUFDS_LDPE_LVPECL (D,GE,G,PRE,O,OB);
input D, GE, G, PRE;
output O,OB;

wire D_n,q_p,q_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDPE olatch_p (.D(D),   .GE(GE), .G(G), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDCE olatch_n (.D(D_n), .GE(GE), .G(G), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUF_LVPECL pad_p (.I(q_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUF_LVPECL pad_n (.I(q_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;	

endmodule // OBUFDS_LDPE_LVPECL

// *************************************
// Start of the Tri-State Output Buffers
// Tri-state output flipflops
// *************************************

module OBUFTDS_FD_LVPECL (D,T,C,O,OB);
input D, T, C;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;
wire CLR = 0;

INV inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_p (.D(T),   .C(C), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_n (.D(T),   .C(C), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FD_LVPECL

module OBUFTDS_FDE_LVPECL (D,T,CE,C,O,OB);
input D, T, CE, C;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p)); 
		/* synthesis syn_noprune = 1 IOB = true */ ;
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FDE_LVPECL
 
module OBUFTDS_FDC_LVPECL (D,T,C,CLR,O,OB);
input D, T, C, CLR;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_p (.D(T),   .C(C), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_n (.D(T),   .C(C), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FDC_LVPECL

module OBUFTDS_FDCE_LVPECL (D,T,CE,C,CLR,O,OB);
input D, T, CE, C, CLR;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FDCE_LVPECL

module OBUFTDS_FDP_LVPECL (D,T,C,PRE,O,OB);
input D, T, C, PRE;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDP off_p (.D(D),   .C(C), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDC off_n (.D(D_n), .C(C), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_p (.D(T),   .C(C), .PRE(PRE), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_n (.D(T),   .C(C), .PRE(PRE), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FDP_LVPECL

module OBUFTDS_FDPE_LVPECL (D,T,CE,C,PRE,O,OB);
input D, T, CE, C, PRE;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDPE off_p (.D(D),   .CE(CE), .C(C), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDCE off_n (.D(D_n), .CE(CE), .C(C), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(PRE), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(PRE), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FDPE_LVPECL

module OBUFTDS_FDR_LVPECL (D,T,C,R,O,OB);
input D, T, C, R;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDR off_p (.D(D),   .C(C), .R(R), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS off_n (.D(D_n), .C(C), .S(R), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS tri_p (.D(T),   .C(C), .S(R), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS tri_n (.D(T),   .C(C), .S(R), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FDR_LVPECL

module OBUFTDS_FDRE_LVPECL (D,T,CE,C,R,O,OB);
input D, T, CE, C, R;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDRE off_p (.D(D),   .CE(CE), .C(C), .R(R), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE off_n (.D(D_n), .CE(CE), .C(C), .S(R), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE tri_p (.D(T),   .CE(CE), .C(C), .S(R), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE tri_n (.D(T),   .CE(CE), .C(C), .S(R), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FDRE_LVPECL

module OBUFTDS_FDS_LVPECL (D,T,C,S,O,OB);
input D, T, C, S;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDS off_p (.D(D),   .C(C), .S(S), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDR off_n (.D(D_n), .C(C), .R(S), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS tri_p (.D(T),   .C(C), .S(S), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS tri_n (.D(T),   .C(C), .S(S), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FDS_LVPECL

module OBUFTDS_FDSE_LVPECL (D,T,CE,C,S,O,OB);
input D, T, CE, C, S;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDSE off_p (.D(D),   .CE(CE), .C(C), .S(S), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDRE off_n (.D(D_n), .CE(CE), .C(C), .R(S), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE tri_p (.D(T),   .CE(CE), .C(C), .S(S), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE tri_n (.D(T),   .CE(CE), .C(C), .S(S), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_FDSE_LVPECL

// ************************
// Tri-state output LATCHES
// ************************

module OBUFTDS_LD_LVPECL (D,T,G,O,OB);
input D, T, G;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;
wire CLR = 0;

INV inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_p (.D(T),   .G(G), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_n (.D(T),   .G(G), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_LD_LVPECL

module OBUFTDS_LDE_LVPECL (D,T,GE,G,O,OB);
input D, T, GE, G;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_LDE_LVPECL
 
module OBUFTDS_LDC_LVPECL (D,T,G,CLR,O,OB);
input D, T, G, CLR;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_p (.D(T),   .G(G), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_n (.D(T),   .G(G), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_LDC_LVPECL

module OBUFTDS_LDCE_LVPECL (D,T,GE,G,CLR,O,OB);
input D, T, GE, G, CLR;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_LDCE_LVPECL

module OBUFTDS_LDP_LVPECL (D,T,G,PRE,O,OB);
input D, T, G, PRE;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDP olatch_p (.D(D),   .G(G), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDC olatch_n (.D(D_n), .G(G), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_p (.D(T),   .G(G), .PRE(PRE), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_n (.D(T),   .G(G), .PRE(PRE), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_LDP_LVPECL

module OBUFTDS_LDPE_LVPECL (D,T,GE,G,PRE,O,OB);
input D, T, GE, G, PRE;
output O,OB;

wire D_n,q_p,q_n,t_p,t_n /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDPE olatch_p (.D(D),   .GE(GE), .G(G), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDCE olatch_n (.D(D_n), .GE(GE), .G(G), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(PRE), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(PRE), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
OBUFT_LVPECL pad_p (.I(q_p), .T(t_p), .O(O)) /* synthesis syn_noprune = 1 */ ;
OBUFT_LVPECL pad_n (.I(q_n), .T(t_n), .O(OB)) /* synthesis syn_noprune = 1 */ ;

endmodule // OBUFTDS_LDPE_LVPECL

// *********************************
// Start of the Input/Output Buffers
// IO Buffer Flipflops
// *********************************

module IOBUFDS_FD_LVPECL (D,T,C,Q,IO,IOB);
input D, T, C;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_p (.D(T),   .C(C), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_n (.D(T),   .C(C), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDC iff_p (.D(i_p), .C(C), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FD_LVPECL

module IOBUFDS_FDE_LVPECL (D,T,CE,C,Q,IO,IOB);
input D, T, CE, C;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDCE iff_p (.D(i_p), .CE(CE), .C(C), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FDE_LVPECL

module IOBUFDS_FDC_LVPECL (D,T,C,CLR,Q,IO,IOB);
input D, T, C, CLR;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDC off_p (.D(D),   .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP off_n (.D(D_n), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_p (.D(T),   .C(C), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_n (.D(T),   .C(C), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDC iff_p (.D(i_p), .C(C), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FDC_LVPECL

module IOBUFDS_FDCE_LVPECL (D,T,CE,C,CLR,Q,IO,IOB);
input D, T, CE, C, CLR;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDCE off_p (.D(D),   .CE(CE), .C(C), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE off_n (.D(D_n), .CE(CE), .C(C), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDCE iff_p (.D(i_p), .CE(CE), .C(C), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FDCE_LVPECL

module IOBUFDS_FDP_LVPECL (D,T,C,PRE,Q,IO,IOB);
input D, T, C, PRE;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDP off_p (.D(D),   .C(C), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDC off_n (.D(D_n), .C(C), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_p (.D(T),   .C(C), .PRE(PRE), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP tri_n (.D(T),   .C(C), .PRE(PRE), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDP iff_p (.D(i_p), .C(C), .PRE(PRE), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FDP_LVPECL

module IOBUFDS_FDPE_LVPECL (D,T,CE,C,PRE,Q,IO,IOB);
input D, T, CE, C, PRE;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDPE off_p (.D(D),   .CE(CE), .C(C), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDCE off_n (.D(D_n), .CE(CE), .C(C), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_p (.D(T),   .CE(CE), .C(C), .PRE(PRE), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE tri_n (.D(T),   .CE(CE), .C(C), .PRE(PRE), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDPE iff_p (.D(i_p), .CE(CE), .C(C), .PRE(PRE), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FDPE_LVPECL

module IOBUFDS_FDR_LVPECL (D,T,C,R,Q,IO,IOB);
input D, T, C, R;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDR off_p (.D(D),   .C(C), .R(R), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS off_n (.D(D_n), .C(C), .S(R), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS tri_p (.D(T),   .C(C), .S(R), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS tri_n (.D(T),   .C(C), .S(R), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDR iff_p (.D(i_p), .C(C), .R(R), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FDR_LVPECL

module IOBUFDS_FDRE_LVPECL (D,T,CE,C,R,Q,IO,IOB);
input D, T, CE, C, R;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDRE off_p (.D(D),   .CE(CE), .C(C), .R(R), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE off_n (.D(D_n), .CE(CE), .C(C), .S(R), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE tri_p (.D(T),   .CE(CE), .C(C), .S(R), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE tri_n (.D(T),   .CE(CE), .C(C), .S(R), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDRE iff_p (.D(i_p), .CE(CE), .C(C), .R(R), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FDRE_LVPECL

module IOBUFDS_FDS_LVPECL (D,T,C,S,Q,IO,IOB);
input D, T, C, S;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDS off_p (.D(D),   .C(C), .S(S), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDR off_n (.D(D_n), .C(C), .R(S), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS tri_p (.D(T),   .C(C), .S(S), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS tri_n (.D(T),   .C(C), .S(S), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDS iff_p (.D(i_p), .C(C), .S(S), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FDS_LVPECL

module IOBUFDS_FDSE_LVPECL (D,T,CE,C,S,Q,IO,IOB);
input D, T, CE, C, S;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
FDSE off_p (.D(D),   .CE(CE), .C(C), .S(S), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDRE off_n (.D(D_n), .CE(CE), .C(C), .R(S), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE tri_p (.D(T),   .CE(CE), .C(C), .S(S), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE tri_n (.D(T),   .CE(CE), .C(C), .S(S), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
FDSE iff_p (.D(i_p), .CE(CE), .C(C), .S(S), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_FDSE_LVPECL

// ***************
// IO Buffer Latch
// ***************
module IOBUFDS_LD_LVPECL (D,T,G,Q,IO,IOB);
input D, T, G;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_p (.D(T),   .G(G), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_n (.D(T),   .G(G), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDC ilatch_p (.D(i_p), .G(G), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_LD_LVPECL

module IOBUFDS_LDE_LVPECL (D,T,GE,G,Q,IO,IOB);
input D, T, GE, G;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;
wire CLR = 0;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDCE ilatch_p (.D(i_p), .GE(GE), .G(G), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_LDE_LVPECL

module IOBUFDS_LDC_LVPECL (D,T,G,CLR,Q,IO,IOB);
input D, T, G, CLR;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDC olatch_p (.D(D),   .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP olatch_n (.D(D_n), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_p (.D(T),   .G(G), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDP tri_n (.D(T),   .G(G), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDC ilatch_p (.D(i_p), .G(G), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_LDC_LVPECL

module IOBUFDS_LDCE_LVPECL (D,T,GE,G,CLR,Q,IO,IOB);
input D, T, GE, G, CLR;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDCE olatch_p (.D(D),   .GE(GE), .G(G), .CLR(CLR), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE olatch_n (.D(D_n), .GE(GE), .G(G), .PRE(CLR), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(CLR), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDCE ilatch_p (.D(i_p), .GE(GE), .G(G), .CLR(CLR), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_LDCE_LVPECL

module IOBUFDS_LDP_LVPECL (D,T,G,PRE,Q,IO,IOB);
input D, T, G, PRE;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDPE olatch_p (.D(D),   .G(G), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDCE olatch_n (.D(D_n), .G(G), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_p (.D(T),   .G(G), .PRE(PRE), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_n (.D(T),   .G(G), .PRE(PRE), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE ilatch_p (.D(i_p), .G(G), .PRE(PRE), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_LDP_LVPECL

module IOBUFDS_LDPE_LVPECL (D,T,GE,G,PRE,Q,IO,IOB);
input D, T, GE, G, PRE;
output Q;
inout IO,IOB;

wire D_n,q_p,q_n,t_p,t_n,i_p /* synthesis syn_keep = 1 */ ;

INV  inv_n (.I(D), .O(D_n)) /* synthesis syn_noprune = 1 */ ;
LDPE olatch_p (.D(D),   .GE(GE), .G(G), .PRE(PRE), .Q(q_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDCE olatch_n (.D(D_n), .GE(GE), .G(G), .CLR(PRE), .Q(q_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_p (.D(T),   .GE(GE), .G(G), .PRE(PRE), .Q(t_p)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE tri_n (.D(T),   .GE(GE), .G(G), .PRE(PRE), .Q(t_n)) /* synthesis syn_noprune = 1 IOB = true */ ;
LDPE ilatch_p (.D(i_p), .GE(GE), .G(G), .PRE(PRE), .Q(Q)) /* synthesis syn_noprune = 1 IOB = true */ ;
IOBUF_LVPECL pad_p (.I(q_p), .T(t_p), .O(i_p), .IO(IO)) /* synthesis syn_noprune = 1 */ ;
IOBUF_LVPECL pad_n (.I(q_n), .T(t_n), .O()   , .IO(IOB)) /* synthesis syn_noprune = 1 */ ;

endmodule // IOBUFDS_LDPE_LVPECL









